//
//  ViewController.h
//
//  Created by Steffan Walters on 10/11/2012.
//  Copyright (c) 2012 Steffan Walters. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <CoreMIDI/CoreMIDI.h>
#import "PdDispatcher.h"
#import <AVFoundation/AVFoundation.h>
#import "effectView.h"

//Tutorial from Making Musical Apps book followed to load a Pure Data patch into the xCode application
//MIDI input code adapted from Learning Core Audio - A hands-On guide to Audio Programming for Mac and iOS - chapter 11 Core MIDI

@interface ViewController : UIViewController <UITableViewDataSource, UITableViewDelegate>{
    PdDispatcher *normalDispatcher;
    void *normalPatch;
}

/*START IBOUTLETS*/
@property (strong, nonatomic) IBOutlet UITableView *tvFileLoad; //table for drum files
@property (strong, nonatomic) IBOutlet UIButton *btnPlayDrums;  //play drums button
@property (strong, nonatomic) IBOutlet UIButton *btnStopDrums;  //stop drums button

@property (strong, nonatomic) IBOutlet UITextView *tvLabelOutput;   //text view outlet for debugging

@property (strong, nonatomic) IBOutlet UIButton *btnPlayRecording;  //play recorded sequence button

@property (strong, nonatomic) IBOutlet UISlider *sliTremelo;        //tremelo slider
@property (strong, nonatomic) IBOutlet UISlider *sliTremeloRange;   //tremelo slider2
@property (strong, nonatomic) IBOutlet UILabel *lblTremeloValue;    //tremelo label
@property (strong, nonatomic) IBOutlet UILabel *lblTremeloRange;    //tremelo label 2

@property (strong, nonatomic) IBOutlet UIView *viewEffectSuper; //UIView - tremelo via gestures

@property (strong, nonatomic) IBOutlet UISlider *sliSustain;    //envelope outlet
@property (strong, nonatomic) IBOutlet UISlider *sliAattack;    //envelope outlet
@property (strong, nonatomic) IBOutlet UISlider *sliDecay;      //envelope outlet
@property (strong, nonatomic) IBOutlet UISlider *sliRelease;    //envelope outlet

@property (strong, nonatomic) IBOutlet UISegmentedControl *sgSoundType; //sound type outler
@property (strong, nonatomic) IBOutlet UIButton *btnRandom;     //random arpegio outlet
@property (strong, nonatomic) IBOutlet UIButton *btnUp;         //up arpegio outlet
@property (strong, nonatomic) IBOutlet UIButton *btnDiminish;   //diminish outlet
@property (strong, nonatomic) IBOutlet UIButton *btnChords;     //chord outlet

/*END IBOUTLETS*/

/*START IBACTIONS*/
- (IBAction)actionPlayDrums:(id)sender;     //play drums
- (IBAction)actionStopDrums:(id)sender;     //stop drums

- (IBAction)actionConnectKeyboard:(id)sender;   //connect keyboard

- (IBAction)sgSoundTypeChange:(id)sender;   //change sound type

- (IBAction)actionClearText:(id)sender; //clear text from text view

- (IBAction)actionRecord:(id)sender;    //record midi input
- (IBAction)actionPlaybackRecording:(id)sender; //playback recorded sequence

- (IBAction)actionRandomArpegio:(id)sender; //random arpegio effect
- (IBAction)actionUpArpegio:(id)sender;     //up arpegio effect
- (IBAction)actionDiminished:(id)sender;    //diminisehd effect
- (IBAction)actionChord:(id)sender; //chord effect

- (IBAction)actionsliTremeloChange:(id)sender;      //tremelo parameters changed
- (IBAction)actionsliTremeloRangeChange:(id)sender; //tremelo parameters changed
- (IBAction)actionTapGesture:(id)sender;            //tremelo parameters changed
- (IBAction)actionPanGesture:(id)sender;            //tremelo parameters changed

- (IBAction)actionSustainChange:(id)sender;     //envelope parameters changed
- (IBAction)actionAttackChange:(id)sender;      //envelope parameters changed
- (IBAction)actionDecayChange:(id)sender;       //envelope parameters changed
- (IBAction)actionReleaseChange:(id)sender;     //envelope parameters changed
/*END IBACTIONS*/

@end